Index: channels/chan_h323.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_h323.c,v
retrieving revision 1.58
diff -u -r1.58 chan_h323.c
--- channels/chan_h323.c	14 Jun 2004 21:18:52 -0000	1.58
+++ channels/chan_h323.c	15 Jun 2004 14:48:15 -0000
@@ -1118,13 +1118,41 @@
 	}
 
 exit:
+#if 0
 	/* allocate a channel and tell asterisk about it */
 	c = oh323_new(p, AST_STATE_RINGING, cd.call_token);
 	if (!c) {
 		ast_log(LOG_ERROR, "Couldn't create channel. This is bad\n");
 		return 0;
 	}
+#endif
+	return 1;
+}
 
+/**
+ * Call-back function to start PBX when OpenH323 ready to serve incoming call
+ *
+ * Returns 1 on success
+ */
+static int answer_call(unsigned call_reference)
+{
+	struct oh323_pvt *p = NULL;
+	struct ast_channel *c = NULL;
+	
+	/* Find the call or allocate a private structure if call not found */
+	p = find_call(call_reference);
+	
+	if (!p) {
+		ast_log(LOG_ERROR, "Something is wrong: answer_call\n");
+		return 0;
+	}
+	
+	/* allocate a channel and tell asterisk about it */
+	c = oh323_new(p, AST_STATE_RINGING, p->cd.call_token);
+	if (!c) {
+		ast_log(LOG_ERROR, "Couldn't create channel. This is bad\n");
+		return 0;
+	}
 	return 1;
 }
 
@@ -1857,7 +1885,8 @@
 				       cleanup_connection, 
 				       chan_ringing,
 				       connection_made, 
-				       send_digit);	
+				       send_digit,
+				       answer_call);
 	
 
 		/* start the h.323 listener */
Index: channels/h323/ast_h323.cpp
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/h323/ast_h323.cpp,v
retrieving revision 1.50
diff -u -r1.50 ast_h323.cpp
--- channels/h323/ast_h323.cpp	26 May 2004 19:14:51 -0000	1.50
+++ channels/h323/ast_h323.cpp	15 Jun 2004 14:48:18 -0000
@@ -489,6 +489,9 @@
 																   const H323SignalPDU & /*setupPDU*/,
 																   H323SignalPDU & /*connectPDU*/)
 {
+	if (!on_answer_call(GetCallReference()))
+		return H323Connection::AnswerCallDenied;
+
 	/* The call will be answered later with "AnsweringCall()" function.
 	 */ 
 	return H323Connection::AnswerCallDeferred;
@@ -835,7 +838,8 @@
  			    clear_con_cb	clfunc,
  			    chan_ringing_cb     rfunc,
 			    con_established_cb 	efunc,
- 			    send_digit_cb	dfunc)
+ 			    send_digit_cb	dfunc,
+ 			    answer_call_cb	acfunc)
 {
 	on_incoming_call = ifunc;
 	on_outgoing_call = sfunc;
@@ -845,6 +849,7 @@
 	on_chan_ringing = rfunc;
 	on_connection_established = efunc;
 	on_send_digit = dfunc;
+	on_answer_call = acfunc;
 }
 
 /**
Index: channels/h323/chan_h323.h
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/h323/chan_h323.h,v
retrieving revision 1.20
diff -u -r1.20 chan_h323.h
--- channels/h323/chan_h323.h	20 May 2004 07:05:26 -0000	1.20
+++ channels/h323/chan_h323.h	15 Jun 2004 14:48:19 -0000
@@ -153,6 +153,9 @@
 typedef void (*clear_con_cb)(call_details_t);
 clear_con_cb		on_connection_cleared;
 
+typedef int (*answer_call_cb)(unsigned);
+answer_call_cb		on_answer_call;
+
 /* debug flag */
 int h323debug;
 
@@ -178,7 +181,8 @@
  				    clear_con_cb,
  				    chan_ringing_cb,
 				    con_established_cb,
- 				    send_digit_cb);
+ 				    send_digit_cb,
+ 				    answer_call_cb);
 
 
 	int h323_set_capability(int, int);
